untyped

global function OnWeaponPrimaryAttack_shifter
global function MpAbilityShifterWeapon_Init
global function MpAbilityShifterWeapon_OnWeaponTossPrep
global function AbilityShifter_ApplyInProgressStimIfNeeded

#if SERVER
global function createindicator
global table<string, vector> playerorigpostable
global table<string, bool> playerrewindusedtable



//make a dict with the player name as key and location vector as content
//global bool rewindused = false
#endif

const SHIFTER_WARMUP_TIME = 0.0
const SHIFTER_WARMUP_TIME_FAST = 0.0

const string PHASEEXIT_IMPACT_TABLE_PROJECTILE	= "default"
const string PHASEEXIT_IMPACT_TABLE_TRACE		= "superSpectre_groundSlam_impact"

struct
{
	int phaseExitExplodeImpactTable
} file;

void function MpAbilityShifterWeapon_Init()
{
	// "exp_rocket_archer"
	// "exp_xlarge"
	// "exp_arc_ball"
	file.phaseExitExplodeImpactTable = PrecacheImpactEffectTable( PHASEEXIT_IMPACT_TABLE_PROJECTILE )
	PrecacheImpactEffectTable( PHASEEXIT_IMPACT_TABLE_TRACE )
}

void function MpAbilityShifterWeapon_OnWeaponTossPrep( entity weapon, WeaponTossPrepParams prepParams )
{
	entity weaponOwner = weapon.GetWeaponOwner()
	int pmLevel = GetPVEAbilityLevel( weapon )
	if ( (pmLevel >= 2) && IsValid( weaponOwner ) && weaponOwner.IsPhaseShifted() )
		weapon.SetScriptTime0( Time() )
	else
		weapon.SetScriptTime0( 0.0 )
}

int function GetPVEAbilityLevel( entity weapon )
{
	if ( weapon.HasMod( "pm2" ) )
		return 2
	if ( weapon.HasMod( "pm1" ) )
		return 1
	if ( weapon.HasMod( "pm0" ) )
		return 0

	return -1
}


/////////////////////////////////////////modified act func///////////////////////////////////////////////////
const float PMMOD_ENDLESS_STRENGTH = 0.8
var function OnWeaponPrimaryAttack_shifter( entity weapon, WeaponPrimaryAttackParams attackParams ){

	#if SERVER
	entity player = weapon.GetWeaponOwner()
	entity indicatorent




	if (weapon.GetWeaponPrimaryClipCount() == 400 ) { //first charge
		thread move (player , weapon)
		addplayerorigpos(player,player.GetOrigin())
		indicatorent = createindicator(getplayerorigpos(player))
	}
	else if(weapon.GetWeaponPrimaryClipCount() == 200 && GetCurrentPlaylistVarInt("#Enable_Phase_Rewind",1) == 1) { //second charge
		thread moveback(player,getplayerorigpos(player))
		weapon.SetWeaponPrimaryClipCount(0)
		player.TouchGround()//allways allows a double jump after phasing back
	}

	thread cooldownmngmnt (weapon,indicatorent)

	#endif
	return 0

}

///////////////////////////////////keeping track of player origpos'/////////////////////////////////////
#if SERVER
void function addplayerorigpos(entity player,vector origpos) {
	string playername = player.GetPlayerName()
	playerorigpostable[playername] <- origpos;
}

vector function getplayerorigpos(entity player){
	return playerorigpostable[player.GetPlayerName()]
}
#endif





///////////////////////////////////////////////////////////////////////////////////////////////////////

void function ApplyInProgressStimIfNeededThread( entity player )
{
	wait 0.5  // timed to kick in when the notify appears on player's screen

	if ( !IsAlive( player ) )
		return
	if ( !player.IsPhaseShifted() )
		return

	EndlessStimBegin( player, PMMOD_ENDLESS_STRENGTH )
}

void function AbilityShifter_ApplyInProgressStimIfNeeded( entity player )
{
	thread ApplyInProgressStimIfNeededThread( player )
}

void function DoPhaseExitExplosion( entity player, entity phaseWeapon )
{
#if CLIENT
	if ( !phaseWeapon.ShouldPredictProjectiles() )
		return
#endif //

	player.PhaseShiftCancel()

	vector origin = player.GetWorldSpaceCenter() + player.GetForwardVector() * 16.0

	DebugDrawLine( player.GetWorldSpaceCenter(), origin, 255, 0, 0, true, 5.0 )

	int damageType = (DF_RAGDOLL | DF_EXPLOSION | DF_ELECTRICAL)
	entity nade = phaseWeapon.FireWeaponGrenade( origin, <0,0,1>, <0,0,0>, 0.01, damageType, damageType, true, true, true )
	if ( !nade )
		return

	player.PhaseShiftBegin( 0, 1.0 )

	nade.SetImpactEffectTable( file.phaseExitExplodeImpactTable )
	nade.GrenadeExplode( <0,0,0> )

#if SERVER
	PlayImpactFXTable( player.GetOrigin(), player, PHASEEXIT_IMPACT_TABLE_TRACE, SF_ENVEXPLOSION_INCLUDE_ENTITIES )
#endif //
}

/////////////////////////////////////////custom functions///////////////////////////////////////////////////
#if SERVER

void function move (entity player, entity weapon) {

	float velmultiplier;

	if (GetCurrentPlaylistVarInt("#Boost_Strength",0) == 0) {velmultiplier = 1;}
	if(GetCurrentPlaylistVarInt("#Boost_Strength",0) == 1){velmultiplier = 1.5;}
	if(GetCurrentPlaylistVarInt("#Boost_Strength",0) == 2){velmultiplier = 2;}

	PhaseShift(player, 0, 0.3 )
	vector viewvector = player.GetViewVector() * 1000 * velmultiplier
	player.SetVelocity(viewvector)
	weapon.SetWeaponPrimaryClipCount(200)

}

void function moveback (entity player , vector origpos) {

	playerrewindusedtable[player.GetPlayerName()] <- true
	entity mover = CreateOwnedScriptMover (player)
	player.SetParent(mover)
	PhaseShift(player, 0, 0.55 )
	mover.NonPhysicsMoveTo (<origpos.x,origpos.y,origpos.z + 50>, 0.5,0,0) //bit of added z height to prevent getting stuck
	wait 0.55;
	player.SetVelocity(<0,0,0>)
	player.ClearParent()
	mover.Destroy()

}

void function cooldownmngmnt (entity weapon,entity indicatorent) {

	//if (ongoingcount == false) { //function gets called twice in ability "cycle" , prevents two timers from going at the same time
	//	ongoingcount = true

		//possible rewind window//
		if (GetCurrentPlaylistVarInt("#Enable_Phase_Rewind",1) == 1) {
			int x = 0
			int deco_x = 5
			while (x < 5) {
				try{if (playerrewindusedtable[weapon.GetWeaponOwner().GetPlayerName()] == true) {break}}catch(ex){print(ex)}
				try {SendHudMessage(weapon.GetWeaponOwner(),"Rewind Possible: "+string(deco_x),-1,0.65,255,255,255,1,0,1,0)}
				catch(ex0) {print("Phase Error:"+ex0)}
				x++
				deco_x = deco_x -1
				wait 1;
			}
		}

		//needs to be 0ed in case the player didnt phase back
		deleteindicator(indicatorent)
		try {weapon.SetWeaponPrimaryClipCount(0)} //I cant be bothered to fix this , doesnt matter anyway the player is dead if this errors out
		catch (ex1) {print("Phase Error:"+ex1)}

		//cooldown//
		int cooldownint = GetCurrentPlaylistVarInt("#Boost_Cooldown", 5)
		wait cooldownint


		try {
			weapon.SetWeaponPrimaryClipCount(400)
			playerrewindusedtable[weapon.GetWeaponOwner().GetPlayerName()] <- false
			SendHudMessage(weapon.GetWeaponOwner(),"Boost Ready!",-1,0.65,255,255,255,1,0,1,0) //player //text //x //y //r //g //b  /a  //fade-in s //lenght s //fade-out s
		} catch(ex2) {print("Phase Error:"+ex2)}

	//	ongoingcount = false
	//}

}

entity function createindicator (vector location) {

	if (GetCurrentPlaylistVarInt("#Enable_Phase_Rewind",1) == 1) {
		entity ind = CreateEntity( "prop_dynamic" )
		ind.SetValueForModelKey( $"models/fx/core_energy.mdl" )
		ind.SetOrigin( <location.x,location.y,location.z+50>)
		DispatchSpawn( ind )

		thread indicatortimeout(ind)

		return ind
	}

}

void function indicatortimeout(entity indicator) {
	wait 10
	try{indicator.Destroy()}
	catch(ex){print("Phase Error:"+ex)}
}

void function deleteindicator (entity indicator) {

	if (IsValid(indicator)) {
		indicator.Destroy()
	} else (print("Phase Error:"+"wasnt valid"))

}



#endif





//dev/engagement_range_human
//imc_interior/imc_int_trashbin_01
///models/humans/grunts/imc_grunt_lmg.mdl